<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <link rel="stylesheet" href="css.css">
</head>
<body onload="onPageLoading()">
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand" href="#">Navbar</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
  
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item active ">
          <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
          
        </li>
        <li class="nav-item">
          <a class="nav-link" href="#">Link</a>
        </li>
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            Dropdown
          </a>
          <div class="dropdown-menu" aria-labelledby="navbarDropdown">
            <a class="dropdown-item" href="#">Action</a>
            <a class="dropdown-item" href="#">Another action</a>
            <div class="dropdown-divider"></div>
            <a class="dropdown-item" href="#">Something else here</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link disabled" href="#">Disabled</a>
        </li>
      </ul>
      <form class="form-inline my-2 my-lg-0">
        <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
        <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
      </form>
    </div>
  </nav>
  <nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="#">Home</a></li>
      <li class="breadcrumb-item" aria-current="page"><a href="#">List User</a></li>
    </ol>
  </nav>
  
  <div class="sidebar">
    <a class="active" href="#home">Home</a>
    <a href="#news">News</a>
    <a href="#contact">Contact</a>
    <a href="#about">About</a>
  </div>
   <!-- User Data Table -->
   <div class="container">
    <div class="text-center my-4">
        <h2>Danh sách người dùng đăng ký</h2>
    </div>
    <input type="button" class="btn btn-success form-group" value="Thêm User" id="btn-add-user" data-toggle='modal' data-target='#insert-user-modal'> 
    <table class="table table-bordered table-striped table-hover text-center" id="user-table">
        <thead>
        <tr>
            <th>Id</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Country</th>
            <th>Subject</th>
            <th>Customer Type</th>
            <th>Register Status</th>
            <th>Action</th>
        </tr>
        </thead>
        <tbody>
        </tbody>
    </table>
</div>
<!-- Vùng Modal -->

<!-- Create user modal -->
<div id="insert-user-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Thêm User</h5>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body"> 
                <form>
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>First name</label>
                        </div>
                        <div class="col-sm-8">
                        <input class="form-control" id="inp-firstname">
                        </div>
                    </div>    
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>Last name</label>
                        </div>
                        <div class="col-sm-8">
                        <input class="form-control" id="inp-lastname">
                        </div>
                    </div>    
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>Subject</label>
                        </div>
                        <div class="col-sm-8">
                        <input class="form-control" id="inp-subject">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>Country</label>
                        </div>
                        <div class="col-sm-8">
                        <select id="select-country" class="form-control">
                            <option value="NOT_SELECT_COUNTRY">Select Country</option>
                            <option value="VN">Việt Nam</option>
                            <option value="USA">USA</option>
                            <option value="AUS">Australia</option>
                            <option value="CAN">Canada</option>
                        </select>
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer">
                <button class="btn btn-success" id="btn-create-user">Insert User</button>
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
            </div>
        </div>
    </div>
</div>
<!-- Vùng Modal -->

<!-- Update user modal -->
<div id="update-user-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Chi tiết User User</h5>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body"> 
                <form>
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>First name</label>
                        </div>
                        <div class="col-sm-8">
                        <input class="form-control" id="inp-update-firstname">
                        </div>
                    </div>    
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>Last name</label>
                        </div>
                        <div class="col-sm-8">
                        <input class="form-control" id="inp-update-lastname">
                        </div>
                    </div>    
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>Subject</label>
                        </div>
                        <div class="col-sm-8">
                        <input class="form-control" id="inp-update-subject">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>Country</label>
                        </div>
                        <div class="col-sm-8">
                        <select id="select-update-country" class="form-control">
                            <option value="NOT_SELECT_COUNTRY">Select Country</option>
                            <option value="VN">Việt Nam</option>
                            <option value="USA">USA</option>
                            <option value="AUS">Australia</option>
                            <option value="CAN">Canada</option>
                        </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>Customer Type</label>
                        </div>
                        <div class="col-sm-8">
                        <select id="select-update-customer-type" class="form-control">
                            <option value="NOT_SELECT_CUSTOMER_TYPE">Select Customer Type</option>
                            <option value="Standard">Standard</option>
                            <option value="Gold">Gold</option>
                            <option value="Premium">Premium</option>
                        </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                        <label>Register status</label>
                        </div>
                        <div class="col-sm-8">
                        <select id="select-update-register-status" class="form-control">
                            <option value="NOT_SELECT_REGISTER_STATUS">Select Register status</option>
                            <option value="Accepted">Accepted</option>
                            <option value="Denied">Denied</option>
                            <option value="Standard">Standard</option>
                        </select>
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer">
                <button class="btn btn-success" id="btn-update-user">Update User</button>
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
            </div>
        </div>
    </div>
</div>
<!-- Vùng Modal -->

<!-- Delete confirm modal -->
<div id="delete-user-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Confirm xóa user</h5>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body"> 
                <p>Bạn có chắc chắn muốn xóa user này không?</p>
            </div>
            <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-user">Xác nhận</button>
                <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
        </div>
    </div>
</div>
<!-- Vùng Modal -->
  <!-- -->
    <!-- Site footer -->
    <footer class="site-footer">
      <div class="container">
        <div class="row">
          <div class="col-sm-12 col-md-6">
            <h6>About</h6>
            <p class="text-justify">Scanfcode.com <i>CODE WANTS TO BE SIMPLE </i> is an initiative  to help the upcoming programmers with the code. Scanfcode focuses on providing the most efficient code or snippets as the code wants to be simple. We will help programmers build up concepts in different programming languages that include C, C++, Java, HTML, CSS, Bootstrap, JavaScript, PHP, Android, SQL and Algorithm.</p>
          </div>

          <div class="col-xs-6 col-md-3">
            <h6>Categories</h6>
            <ul class="footer-links">
              <li><a href="http://scanfcode.com/category/c-language/">C</a></li>
              <li><a href="http://scanfcode.com/category/front-end-development/">UI Design</a></li>
              <li><a href="http://scanfcode.com/category/back-end-development/">PHP</a></li>
              <li><a href="http://scanfcode.com/category/java-programming-language/">Java</a></li>
              <li><a href="http://scanfcode.com/category/android/">Android</a></li>
              <li><a href="http://scanfcode.com/category/templates/">Templates</a></li>
            </ul>
          </div>

          <div class="col-xs-6 col-md-3">
            <h6>Quick Links</h6>
            <ul class="footer-links">
              <li><a href="http://scanfcode.com/about/">About Us</a></li>
              <li><a href="http://scanfcode.com/contact/">Contact Us</a></li>
              <li><a href="http://scanfcode.com/contribute-at-scanfcode/">Contribute</a></li>
              <li><a href="http://scanfcode.com/privacy-policy/">Privacy Policy</a></li>
              <li><a href="http://scanfcode.com/sitemap/">Sitemap</a></li>
            </ul>
          </div>
        </div>
        <hr>
      </div>
      <div class="container">
        <div class="row">
          <div class="col-md-8 col-sm-6 col-xs-12">
            <p class="copyright-text">Copyright &copy; 2017 All Rights Reserved by 
         <a href="#">Scanfcode</a>.
            </p>
          </div>

          <div class="col-md-4 col-sm-6 col-xs-12">
            <ul class="social-icons">
              <li><a class="facebook" href="#"><i class="fa fa-facebook"></i></a></li>
              <li><a class="twitter" href="#"><i class="fa fa-twitter"></i></a></li>
              <li><a class="dribbble" href="#"><i class="fa fa-dribbble"></i></a></li>
              <li><a class="linkedin" href="#"><i class="fa fa-linkedin"></i></a></li>   
            </ul>
          </div>
        </div>
      </div>
</footer>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */ 
    var gCountryObjects = [
        {
          "value": "VN",
          "text": "Việt Nam" 
        },
        {
          "value": "USA",
          "text": "USA" 
        },
        {
          "value": "AUS",
          "text": "Australia" 
        },
        {
          "value": "CAN",
          "text": "Canada" 
        }
    ];
    // Khai báo biến mảng hằng số chứa danh sách tên các thuộc tính
    const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_ID_COL = 0;
    const gUSER_FIRSTNAME_COL = 1;
    const gUSER_LASTNAME_COL = 2;
    const gUSER_COUNTRY_COL = 3;
    const gUSER_SUBJECT_COL= 4;
    const gUSER_CUSTOMER_TYPE_COL = 5;
    const gUSER_REGISTER_STATUS_COL = 6;
    const gUSER_ACTION_COL = 7;
    // Khai báo DataTable & mapping collumns
    var gUserTable = $("#user-table").DataTable({
        columns: [
            { data: gUSER_COLS[gUSER_ID_COL] },
            { data: gUSER_COLS[gUSER_FIRSTNAME_COL] },
            { data: gUSER_COLS[gUSER_LASTNAME_COL] },
            { data: gUSER_COLS[gUSER_COUNTRY_COL] },
            { data: gUSER_COLS[gUSER_SUBJECT_COL] },
            { data: gUSER_COLS[gUSER_CUSTOMER_TYPE_COL] },
            { data: gUSER_COLS[gUSER_REGISTER_STATUS_COL] },
            { data: gUSER_COLS[gUSER_ACTION_COL] },
        ],
        columnDefs: [
            {
                // Định nghĩa lại cột Country
                targets: gUSER_COUNTRY_COL,
                render: function (data) {
                    return getCountryTextByCountryValue(data);
                }
            },
            { // Định nghĩa lại cột Action
                targets: gUSER_ACTION_COL,
                className: "text-center",
                defaultContent: `
                <button class="btn btn-primary btn-edit">Sửa</button>
                <button class="btn btn-danger btn-delete" data-toggle='modal'>Xóa</button>
                `
            }
        ],
        autoWidth: false
    });
    // Biến toàn cục để lưu trữ id user đang được update or delete. Mặc định = 0;
    var gIdOfUser = "";
    //Khai báo biến mảng chứa dữ liệu users
    var gListUsers = [];
    // Khai báo biến hằng số
    const gNOT_SELECT_COUNTRY = "NOT_SELECT_COUNTRY"; // giá trị (value) khi chưa chọn countruy
    const gNOT_SELECT_CUSTOMER_TYPE = "NOT_SELECT_CUSTOMER_TYPE"; // giá trị (value) khi chưa chọn customer type
    const gNOT_SELECT_REGISTER_STATUS ="NOT_SELECT_REGISTER_STATUS"; // giá trị (value) khi chưa chọn register status
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onLoadPaging();
        
        // 2 - C: gán sự kiện Create - Thêm mới user
        $("#btn-add-user").on("click", function() {
            onBtnAddNewUserClick();
        });
        // 3 - U: gán sự kiện Update - Sửa 1 user
        $("#user-table").on("click", ".btn-edit", function(){
            onBtnEditClick(this);
        });
        // 4 - D: gán sự kiện Delete - xóa 1 user
        $("#user-table").on("click", ".btn-delete", function(){ 
            onIconDeleteUserClick(this);
        });

        $("#btn-create-user").on("click", function() {
            onBtnCreateUserClick();
         });
         
         $("#btn-update-user").on("click", function(){
            onBtnUpdateUserClick();
        });

        $("#btn-confirm-delete-user").on("click", function(){ 
            onBtnConfirmDeleteUserClick();
        });
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onLoadPaging(){
        "use strict"; 
        getAllUsers(); 
        // 1 - R: Read / Load user to DataTable
        loadDataToUserTable(gListUsers);
    }
    // Hàm xử lý sự kiện khi nút Thêm mới được click
    function onBtnAddNewUserClick() {
        // hiển thị modal trắng lên
        $("#create-user-modal").modal("show");
    }
    //hàm xử lý sự kiện click nút sửa
    function onBtnEditClick(paramButtonElement){
        "use strict";
        console.log("Button Edit Click!!!");
        var vRowClick = $(paramButtonElement).closest("tr"); //xác định tr chứa nút bấm đc click
        var vTable = $("#user-table").DataTable(); //tạo biến truy xuất đến datatable
        var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
        gIdOfUser = vDataRow.id;
        console.log("ID = " + gIdOfUser);
        showUpdateUserModal(vDataRow);
    }
    // Hàm xử lý sự kiện khi icon delete user trên bảng được click
    function onIconDeleteUserClick(paramButtonElement){
        "use strict";
        var vRowClick = $(paramButtonElement).closest("tr"); //xác định tr chứa nút bấm đc click
        var vTable = $("#user-table").DataTable(); //tạo biến truy xuất đến datatable
        var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
        // lưu thông tin id của user đang được delete vào biến toàn cục
        gIdOfUser = vDataRow.id;
        // hiển thị modal confirm delete lên
        $("#delete-user-modal").modal("show");
    }
    //hàm xử lý sự kiện click nút insert user
    function onBtnCreateUserClick(){
        "use strict";
        // khai báo đối tượng chứa user data
        var vUserObj = {
            firstname: "",
            lastname: "",
            subject: "",
            country: ""
        }
        //B1: thu thập dữ liệu
        getUserDataCreate(vUserObj);
        //B2: Validate insert
        var vIsUserValidate = validateInsertData(vUserObj);        
        if (vIsUserValidate) {
            // B3: insert user
            postUserApi(vUserObj);
            //B4: xử lý front-end 
            //gọi api lấy danh sách user 
            getAllUsers(); 
            // load lại vào bảng (table)
            loadDataToUserTable(gListUsers);
            resertCreateUserForm();
            $("#insert-user-modal").modal("hide"); //ẩn modal form create user
        } 
    }
    //hàm xử lý sự kiện click nút update user
    function onBtnUpdateUserClick(){
        "use strict";
       // khai báo đối tượng chứa user data 
        var vUserObj = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: ""
        }
        //B1: thu thập dữ liệu
        getUserDataUpdate(vUserObj);
         // B2: Validate update
        var vIsUserValidate = validateUpdateData(vUserObj);
        if (vIsUserValidate) { 
            // B3: update user
            updateUserById(vUserObj);
            // B4: xử lý front-end
            //load lại bảng
            getAllUsers(); 
            loadDataToUserTable(gListUsers);
            resetUpdateUserModalForm(); // xóa trắng modal
            $("#update-user-modal").modal("hide"); //ẩn modal form update user
        }
    }
    //hàm xử lý sự kiện click nút confirm delete user
    function onBtnConfirmDeleteUserClick(){
        "use strict";
        // B1: thu thập dữ liệu (ko có)
        // B2: validate (ko có)
        // B3: xóa user
        $.ajax({
            async: false,
            url: "http://203.171.20.210:8080/crud-api/users/" + gIdOfUser,
            type: "DELETE",
            success: function(res){
                console.log(res);
                // B4: xử lý, hiển thị trên front-end
                alert("Đã xóa người dùng thành công!");
            },
            error: function(error){
                alert(error.responseText);
            }
        }); 
        //load lại bảng
        getAllUsers();  
        loadDataToUserTable(gListUsers);
        $("#delete-user-modal").modal("hide"); //ẩn modal form delete user
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm lấy text country theo value của country
    function getCountryTextByCountryValue(paramCountry){
        "use strict";
        var vTextCountry = "";
        for (var bI = 0; bI < gCountryObjects.length; bI++){
                if(gCountryObjects[bI].value == paramCountry){
                vTextCountry = gCountryObjects[bI].text;
            }
        };  
        return vTextCountry;   
    }
    //Hàm gọi API lấy danh sách user
    function getAllUsers(){
        "use strict";
        $.ajax({
            async: false,
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            dataType: "json",
            success: function(res){
                // lấy response trả về và gán cho biến gListUsers
                gListUsers = res;
            },
            error: function(error){
                console.log(error.responseText);
            }
        }) 
    }
    /**  Load user to DataTable
    * in: user array
    * out: user table has data
    */  
    function loadDataToUserTable(paramObjectUsers) {
        console.log(paramObjectUsers);
        gUserTable.clear();
        gUserTable.rows.add(paramObjectUsers);
        gUserTable.draw();
    }
    // hàm thu thập dữ liệu để insert user
    function getUserDataCreate(paramUserObj){
        "use strict";
        paramUserObj.firstname = $("#inp-firstname").val().trim();
        paramUserObj.lastname = $("#inp-lastname").val().trim();
        paramUserObj.subject = $("#inp-subject").val().trim();
        paramUserObj.country = $("#select-country").val();
    }
    // hàm validate data khi insert
    function validateInsertData(paramUserObj){
        "use strict";
        if(paramUserObj.firstname == ""){
            alert("Firstname cần nhập");
            return false;
        };
        if(paramUserObj.lastname == ""){
            alert("Lastname cần nhập");
            return false;
        };
        if(paramUserObj.subject == ""){
            alert("Subject cần nhập");
            return false;
        };
        if(paramUserObj.country == gNOT_SELECT_COUNTRY){
            alert("Country cần chọn");
            return false;
        };
        return true;
    }
    //hàm gọi API insert user
    function postUserApi(paramUserObj){
        "use strict";
        $.ajax({
            async: false,
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "POST",
            data: JSON.stringify(paramUserObj),
            contentType: "application/json",
            success: function(res){
                console.log(res);
                alert("Thêm user thành công!");
            },
            error: function(error){
                alert(error.responseText);
            }
        });
    }
    //hàm hiện modal update cùng thông tin của user
    function showUpdateUserModal(paramDataRow){
        "use strict";
        console.log(paramDataRow);
        $("#update-user-modal").modal("show"); //hiện update modal
        $("#inp-update-firstname").val(paramDataRow.firstname);
        $("#inp-update-lastname").val(paramDataRow.lastname);
        $("#inp-update-subject").val(paramDataRow.subject);
        $("#select-update-country").val(paramDataRow.country);
        $("#select-update-customer-type").val(paramDataRow.customerType);
        $("#select-update-register-status").val(paramDataRow.registerStatus);
    }
    //hàm thu thập dữ liệu nhập trên form update user
    function getUserDataUpdate(paramUserObj){
        "use strict";
        paramUserObj.firstname = $("#inp-update-firstname").val().trim();
        paramUserObj.lastname = $("#inp-update-lastname").val().trim();
        paramUserObj.subject = $("#inp-update-subject").val().trim();
        paramUserObj.country = $("#select-update-country").val();
        paramUserObj.customerType = $("#select-update-customer-type").val();
        paramUserObj.registerStatus = $("#select-update-register-status").val();
    }
    //hàm validate dữ liệu nhập trên form update user
    function validateUpdateData(paramUserObj){
        "use strict";
        if(paramUserObj.firstname == ""){
            alert("Firstname cần nhập");
            return false;
        };
        if(paramUserObj.lastname == ""){
            alert("Lastname cần nhập");
            return false;
        };
        if(paramUserObj.subject == ""){
            alert("Subject cần nhập");
            return false;
        };
        if(paramUserObj.country == gNOT_SELECT_COUNTRY){
            alert("Country cần chọn");
            return false;
        };
        if(paramUserObj.customerType == gNOT_SELECT_CUSTOMER_TYPE){
            alert("Customer Type cần chọn");
            return false;
        };
        if(paramUserObj.registerStatus == gNOT_SELECT_REGISTER_STATUS){
            alert("Register Status cần chọn");
            return false;
        };
        return true;
    }
    // hàm thực hiện update user
    function updateUserById(paramUserObj){
        "use strict";
        $.ajax({
            async: false,
            url: "http://203.171.20.210:8080/crud-api/users/" + gIdOfUser,
            type: "PUT",
            data: JSON.stringify(paramUserObj),
            contentType: "application/json",
            success: function(res){
                console.log(res);
                alert("Đã update user thành công!");
            },
            error: function(error){
                alert(error.responseText);
            }
        });
    }
    // hàm xóa trắng form create user
    function resertCreateUserForm() {
        $("#inp-firstname").val("");
        $("#inp-lastname").val("");
        $("#inp-subject").val("");
        $("#select-country").val(gNOT_SELECT_COUNTRY);
    }
    // hàm xóa trắng form update user
    function resetUpdateUserModalForm(){
        "use strict";
        $("#inp-update-firstname").val("");
        $("#inp-update-lastname").val("");
        $("#inp-update-subject").val("");
        $("#select-update-country").val(gNOT_SELECT_COUNTRY);
        $("#select-update-customer-type").val(gNOT_SELECT_CUSTOMER_TYPE);
        $("#select-update-register-status").val(gNOT_SELECT_REGISTER_STATUS);
    }
    
</script>
</html>